Description

I want to write custom random number generators (RNGs) that can be used as an alternative to a Random object.

Now custom RNGs with #rand method can be used for that purpose, but there is the method call overhead in the current

implementation because #rand method is called through rb_funcallv_public.

I want C API for writing RNGs because all of the random number generator algorithms I want to write are originally written in C.

Nobu already created a pull-request for such purpose.

Related issues:

Related to Ruby - Feature #18463: Random number generation with xoshiro Open

History

#1 - 05/14/2020 08:08 AM - matz (Yukihiro Matsumoto)

Sounds OK. Go ahead.

Matz.

#2 - 05/14/2020 12:33 PM - Eregon (Benoit Daloze)

IMHO it's not nice to replace a nice Ruby-level API by a C API one.

Is there a benchmark of how much is it slower with rb_funcallv_public?

Also, will it still work when passing a custom object understanding rand?

If so, there are two ways to dispatch, doesn't seem nice either API-wise.

#3 - 12/07/2020 02:16 AM - mrkn (Kenta Murata)

- Status changed from Open to Closed

Closed by af5e87ab218c5f4e34c6cdb54ae119a7f0f9033f

#4 - 01/07/2022 11:02 AM - mame (Yusuke Endoh)

- Related to Feature #18463: Random number generation with xoshiro added
